/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __STM32F4x7_PHY_H
#define __STM32F4x7_PHY_H

#include "interface.h"
#include "lwip/netif.h"
#include "lwip_eth.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
#define ETHERNET_PHY_ADDRESS ((uint16_t)0x01)

/* Ethernet Flags for EthStatus variable */
#define ETH_INIT_FLAG 0x01
#define ETH_LINK_FLAG 0x10
void                 eth_init(void);
uint32_t             Eth_Link_PHYITConfig(uint16_t PHYAddress);
void                 Eth_Link_ITHandler(uint16_t PHYAddress);
void                 ETH_link_callback(struct netif *netif);
extern __IO uint32_t EthStatus; /* 提供给主程序使用 */

#endif /* __STM32F4x7_PHY_H */
