#ifndef __RTC_H
#define __RTC_H
#include "stm32f4xx.h"

//////////////////////////////////////////////////////////////////////////////////
//本程序只供学习使用，未经作者许可，不得用于其它任何用途
// ALIENTEK STM32F407开发板
// RTC 驱动代码
//作者:yukang
//创建日期:2018/8/5
//版本：V1.1
//版权所有，盗版必究。
// Copyright(C) 国轩高科  2014-2024
// All rights reserved
//********************************************************************************
//修改说明
// V1.1 20140726
//新增:RTC_Get_Week函数,用于根据年月日信息,得到星期信息.
//////////////////////////////////////////////////////////////////////////////////

uint8_t     MyRTC_Init(void);                                                      // RTC初始化
ErrorStatus RTC_Set_Time(uint8_t hour, uint8_t min, uint8_t sec, uint8_t ampm);    // RTC时间设置
ErrorStatus RTC_Set_Date(uint8_t year, uint8_t month, uint8_t date, uint8_t week); // RTC日期设置
// void RTC_Set_AlarmA(uint8_t week,uint8_t hour,uint8_t min,uint8_t sec);		//设置闹钟时间(按星期闹铃,24小时制)
// void RTC_Set_WakeUp(uint32_t wksel,uint16_t cnt);					//周期性唤醒定时器设置

uint32_t GetCur_TimeStamp(void);

#endif
