#ifndef __UART3_H
#define __UART3_H

#include "interface.h"
#include "queue.h"
#include "stm32f4xx_usart.h"
#include "string.h"

#define UART3_REC_LEN     128
#define UART3_TX_LEN      128
#define UART3_MAX_MSG_NUM 10

#define UART3_DMA      DMA_Channel_4
#define UART3_DMA_RXCH DMA1_Stream1
#define UART3_DMA_TXCH DMA1_Stream3

void uart3_init(void);
void uart3_dma_send(const uint8_t *buf, uint16_t len);

#endif // __UART3_H