
#ifndef __IEC10x_CONF_H
#define __IEC10x_CONF_H

#include "iec10x_type.h"

#define WTP_SUPPORT_END_NUMBER 9

#define RET_SUCESS 0
#define RET_ERROR  1

#define IEC104_SET

#define SIM900_MODE_CLIENT

#define SERIAL_DEBUG

#ifdef SERIAL_DEBUG
#define log(...) printf(__VA_ARGS__)
#define LOG(...) printf(__VA_ARGS__)
#define LogInit()
#define PRINT_FUNLINE printf("%s %d\r\n", __FUNCTION__, __LINE__)
#else
#define log(...)
#define LOG(...)
#define DumpHEX(buffer, len)
#define PRINT_FUNLINE
#endif

#ifdef SERIAL_DEBUG
void DumpHEX(iec_8u *buffer, iec_32u len);
#endif

#endif
