#ifndef LWIP_ETH_H
#define LWIP_ETH_H

// #include "fly_config.h"

//#define USE_DHCP       1 /* enable DHCP, if disabled static address is used */
// extern __lwip_dev ethdev; // lwip控制结构体

#define USE_ETH_INTERRUPT

/* MII and RMII mode selection */
#define RMII_MODE // user have to provide the 50 MHz clock by soldering a 50 MHz oscillator
//#define MII_MODE

/* clock the PHY from external 25MHz crystal (only for MII mode) */
#ifdef MII_MODE
#define PHY_CLOCK_MCO
#endif

#ifdef USE_DHCP
/* dhcp_task */
void dhcp_task(void *pvParameters);
#include "dhcp.h"
#endif /* USE_DHCP */

void lwip_eth_setup(void);

#endif /* NETCONF_H */
