/*
*********************************************************************************************************
*	  : main
*	˵: c
*	    Σ
*	  ֵ: (账)
*********************************************************************************************************
*/

#include "main.h"

void DumpHEX(uint8_t *buffer, uint32_t len)
{

    uint32_t i;
    printf("[DumpHEX]Length:%d ", len);
    for (i = 0; i < len; i++)
    {
        if (i % 16 == 0)
            printf("\r\n");
        else if (i % 8 == 0)
            printf("    ");
        else
            printf(":");
        printf("%02x", buffer[i]);
    }
    printf("\r\n");
}

int main(void)
{
#if 0
    /* GOIOI ˿ʱ */
    *(unsigned int *)(0x40023800 + 0x30) |= (1 << 8);

    /* PI10 Ϊ */
    *(unsigned int *)(0x40022000 + 0x00) &= ~((0x03) << (2 * 10));
    *(unsigned int *)(0x40022000 + 0x00) |= (1 << (2 * 10));

    /* PI10 ߵƽ */
    *(unsigned int *)(0x40022000 + 0x14) |= (1 << 10);
    /* PI10 ͵ƽ */
    *(unsigned int *)(0x40022000 + 0x14) &= ~(1 << 10);
#elif 0
    bsp_init();
    while (1)
    {
        GPIO_ResetBits(GPIOI, GPIO_Pin_10);
        Delay(0xFFFFFFFF);
        // GPIO_SetBits(GPIOI, GPIO_Pin_10);
        // Delay(0xFFFFFFFF);

        GPIO_ResetBits(GPIOF, GPIO_Pin_7);
        Delay(0xFFFFFF);
        // GPIO_SetBits(GPIOF, GPIO_Pin_7);
        // Delay(0xFFFFFF);

        GPIO_ResetBits(GPIOF, GPIO_Pin_8);
        Delay(0xFFFFFF);
        // GPIO_SetBits(GPIOF, GPIO_Pin_8);
        // Delay(0xFFFFFF);

        GPIO_ResetBits(GPIOC, GPIO_Pin_2);
        Delay(0xFFFFFF);
        // GPIO_SetBits(GPIOC, GPIO_Pin_2);
        // Delay(0xFFFFFF);
    };
#elif 1
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
    OSInit();
    bsp_init();
    RegisterIec10x();

    /* init task */
    /* һҲ񣩡ᴴеӦó */
    OSTaskCreateExt(init_task,                                   /* ָ */
                    (void *)0,                                   /* ݸĲ */
                    (OS_STK *)&init_task_stk[INIT_STK_SIZE - 1], /* ָջջָ */
                    INIT_TASK_PRIO,                              /* ȼΨһԽȼԽ */
                    INIT_TASK_PRIO,                              /* IDһȼͬ */
                    (OS_STK *)&init_task_stk[0],                 /* ָջջ׵ָ롣OS_STK_GROWTH
                                                                    ջ */
                    INIT_STK_SIZE,                               /* ջС */
                    (void *)0,                                   /* һûڴָ룬ƿTCBչ
                                                                лʱCPUĴݣһ㲻ã0 */
                    OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR);  /* ѡ */

    OSStart();

#endif
}

/*!
    \brief      init task
    \param[in]  pvParameters not used
    \param[out] none
    \retval     none
*/
void init_task(void *pvParameters)
{
    SysTick_Config(SystemCoreClock / OS_TICKS_PER_SEC);
    /* configure the systick handler priority */
    NVIC_SetPriority(SysTick_IRQn, 0x00U);

    OSTaskCreateExt((void (*)(void *))led_task,                                       /* ָ */
                    (void *)0,                                                        /* ݸĲ */
                    (OS_STK *)&LED_TASK_STK[LED0_STK_SIZE - 1],                       /* ָջջָ */
                    LED_RX_PRIO,                                                      /* ȼΨһԽȼԽ */
                    LED_RX_PRIO,                                                      /* IDһȼͬ */
                    (OS_STK *)&LED_TASK_STK[0],                                       /* ָջջ׵ָ롣OS_STK_GROWTH ջ */
                    LED0_STK_SIZE,                                                    /* ջС */
                    (void *)0,                                                        /* һûڴָ룬ƿTCBչ
                                                                                      лʱCPUĴݣһ㲻ã0 */
                    OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR | OS_TASK_OPT_SAVE_FP); /* ѡ */

    OSTaskCreateExt((void (*)(void *))misc_task,
                    (void *)0,
                    (OS_STK *)&misc_task_stk[MISC_TASK_STK_SIZE - 1],
                    (INT8U)MISC_PRIO,
                    (INT16U)MISC_PRIO,
                    (OS_STK *)&misc_task_stk[0],
                    (INT32U)MISC_TASK_STK_SIZE,
                    (void *)0,
                    (INT16U)OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR | OS_TASK_OPT_SAVE_FP);

    // OSTaskCreateExt((void (*)(void *))modbus_master_task,
    //                 (void *)0,
    //                 (OS_STK *)&uart1_task_stk[UART1_TASK_STK_SIZE - 1],
    //                 (INT8U)UART1_TASK_PRIO,
    //                 (INT16U)UART1_TASK_PRIO,
    //                 (OS_STK *)&uart1_task_stk[0],
    //                 (INT32U)UART1_TASK_STK_SIZE,
    //                 (void *)0,
    //                 (INT16U)OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR | OS_TASK_OPT_SAVE_FP);

    /* 485 modbusӻģʽ */
    OSTaskCreateExt((void (*)(void *))modbus_slave_task,
                    (void *)0,
                    (OS_STK *)&uart3_task_stk[UART3_TASK_STK_SIZE - 1],
                    (INT8U)UART3_TASK_PRIO,
                    (INT16U)UART3_TASK_PRIO,
                    (OS_STK *)&uart3_task_stk[0],
                    (INT32U)UART3_TASK_STK_SIZE,
                    (void *)0,
                    (INT16U)OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR | OS_TASK_OPT_SAVE_FP);

    OSTaskCreateExt((void (*)(void *))net_task,
                    (void *)0,
                    (OS_STK *)&net_task_stk[NET_TASK_STK_SIZE - 1],
                    (INT8U)NET_PRIO,
                    (INT16U)NET_PRIO,
                    (OS_STK *)&net_task_stk[0],
                    (INT32U)NET_TASK_STK_SIZE,
                    (void *)0,
                    (INT16U)OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR | OS_TASK_OPT_SAVE_FP);
}

void misc_task(void)
{
    INT8U  cnt      = 0;
    INT16U save_cnt = 0;
    INT8U  temperature;
    INT8U  humidity;
    INT8U  ret;
    AD7606_SetOS(AD_OS_NO);  /* ޹ */
    AD7606_SetInputRange(0); /* 0ʾΪ5V, 1ʾ10V */

    // bsp_StartAutoTimer(0, 500); /* 1200msԶװĶʱ */
    AD7606_ReadNowAdc();  /* ȡ */
    AD7606_StartConvst(); /* 1ת */
    while (1)
    {
        iwdg_feed(MISC_DOG);
        // if ((cnt % 10 == 0) && (cnt != 0))
        // {
        //     return;
        // }
        if ((cnt % 25 == 0) && (cnt != 0))
        {
            LED2_RUN_TOGGLE;
        }

        // if ((cnt % 15 == 0) && (cnt != 0))
        // {
        //     return;
        // }
        if (cnt == 10)
        {
            // if (am2303_init())
            // {
            //     printf("error\r\n");
            // }
            // else
            // {
            ret = am2303_read_data(&temperature, &humidity); //ȡʪֵ
            if (ret == 1)
            {
                printf("Temp: (%d).\n", temperature);
                printf("Humi: (%d).\n", humidity);
            }
            else
            {
                printf("\r\nδDHT11ʪȴ\r\n");
            }
            // }
        }
        if (cnt >= 25)
        {
            /* ÿ500ms һ. ת */
            AD7606_ReadNowAdc();  /* ȡ */
            AD7606_StartConvst(); /* ´ת */

            cnt = 0; /* ˢʾ */
        }
        else
        {
            cnt++;
        }

        if (save_cnt >= 25)
        {
            save_cnt = 0;
        }
        else
        {
            save_cnt++;
        }
        OSTimeDly(20);
    };
}